## ngspice 37+ds

=== debian/changelog ===
ngspice (37+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 07 Jun 2022 19:55:16 +0200

ngspice (37+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 01 Jun 2022 21:47:07 +0200

ngspice (37+ds-1) unstable; urgency=medium

  * [7b8d014] d/gbp.conf: Remove some files from filtering
    Due information from the upstream author Holger Vogt some files are not
    needed to get removed. The files previously removed are licensed as
    Public Domain.
  * [527ed9b] New upstream version 37+ds
  * [2229711] Drop patch queue
    No patching of the source is currently needed.
    removed patch (fixed upstream):
    fixes/spelling-Fix-misspelled-word-Instnace.patch
    fixes/tcl-testbench-x-.sh-Use-bash-within-shebang.patch
  * [2e83469] d/ngspice.docs: Add upstream notes about lib models
  * [e86af9e] d/copyright: Update info for model libraries

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 29 May 2022 18:12:42 +0200

ngspice (36+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 10 Jan 2022 19:40:35 +0100

ngspice (36+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 09 Jan 2022 19:38:04 +0100

ngspice (35+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 22 Aug 2021 12:44:03 +0200

ngspice (34+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports
  * [dcd9c72] Revert "d/control: increase dh version to 13"
  * [c9b5122] d/libngspice0.symbols: adjust symbol list for 34+ds

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 02 Feb 2021 17:28:46 +0100

=== debian/control ===
Source: ngspice
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders:
 Gudjon I. Gudjonsson <gudjon@gudjon.org>,
 Andreas Tille <tille@debian.org>,
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 automake,
 bison,
 blt-dev,
 debhelper-compat (= 12),
 flex,
 gfortran,
 libedit-dev,
 libncurses5-dev,
 libtool,
 libxaw7-dev,
 tcl8.6,
 tcl8.6-dev,
 texinfo,
 tk8.6,
 tk8.6-dev,
Build-Depends-Indep:
 imagemagick,
 lyx (>= 2.2),
 texlive,
 texlive-lang-greek,
 texlive-latex-extra,
 texlive-plain-generic,
 texlive-science,
Rules-Requires-Root: binary-targets
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/electronics-team/ngspice
Vcs-Git: https://salsa.debian.org/electronics-team/ngspice.git
Homepage: http://ngspice.sourceforge.net
XS-Autobuild: yes

Package: ngspice
Architecture: any
Depends:
 dpkg (>= 1.15.4) | install-info,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ngspice-doc (>= ${source:Version}),
Description: Spice circuit simulator
 NGSpice is a mixed-level/mixed-signal circuit simulator.  Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice.
 .
 NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
 Automation tools.

Package: ngspice-dev
Section: libdevel
Architecture: any
Depends:
 blt-dev,
 tclspice (= ${binary:Version}),
 ${misc:Depends},
Description: Spice circuit simulator - development files for ngspice and tclspice
 NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice.
 .
 Use this package in case you need to compile own Xspice models as a dynamic
 library with a file extension *.cm. Those files need to be placed into
 /usr/lib/$(multiarch)/ngspice and will be loaded by the ngspice executable.
 .
 This package contains the development header files for libspice and own
 ngspice dynamic library models.

Package: tclspice
Section: libs
Architecture: any
Depends:
 blt,
 ngspice (= ${binary:Version}),
 tcl8.6,
 tk8.6,
 ${misc:Depends},
 ${shlibs:Depends},
Description: NGSpice library for Tcl
 This package provides the NGSpice simulation engine for your Tcl-scripts by the
 library libspice.
 All spice directives are available as Tcl functions and it features some new
 commands that are useful for the integration into the Tcl environment. It
 includes Xspice.
 GUI is handled by Tk using BLT vectors.

Package: ngspice-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Documentation for the NGspice circuit simulator
 NGspice is a mixed-level/mixed-signal circuit simulator.
 Its code is based on three open source software packages:
 Spice3f5, Cider1b1 and Xspice.
 .
 NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
 Automation tools.
 .
 This package contains the PDF and HTML documentation.

Package: libngspice0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Spice circuit simulator - library
 NGspice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice.
 .
 This package contains the NGSpice library.

Package: libngspice0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libngspice0 (= ${binary:Version}),
 ${misc:Depends},
Description: Spice circuit simulator - development files for libngspice
 NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
 three open source software packages:
 Spice3f5, Cider1b1 and Xspice.
 .
 This package contains the development files for NGSpice.

## ngspice 38+ds

=== debian/changelog ===
ngspice (38+ds-1) unstable; urgency=medium

  * [2717ce3] New upstream version 38+ds
  * [caf5638] d/copyright: Incorporate upstream changes
  * [e337314] d/control: Update upstream Homepage data
  * [8cfef52] d/control: Increase Standards-Version to 4.6.1
    No further changes needed.
  * [20c0d94] d/libngspice0.symbols: Adjust symbol list for 38+ds
  * [bfa010d] d/control: Remove obsolete field Autobuild

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 29 Oct 2022 19:50:03 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  automake,
  bison,
  blt-dev,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  flex,
  gfortran,
  libedit-dev,
@@ -31,11 +31,10 @@
  texlive-plain-generic,
  texlive-science,
 Rules-Requires-Root: binary-targets
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/electronics-team/ngspice
 Vcs-Git: https://salsa.debian.org/electronics-team/ngspice.git
-Homepage: http://ngspice.sourceforge.net
-XS-Autobuild: yes
+Homepage: https://ngspice.sourceforge.io
 
 Package: ngspice
 Architecture: any

## ngspice 39.3%2Bds

=== debian/changelog ===
ngspice (39.3+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 14 Feb 2023 14:36:24 +0000

ngspice (39.3+ds-1) unstable; urgency=medium

  * [a013609] New upstream version 39.3+ds
  * [0901cae] d/control: Increase Standards-Version to 4.6.2
    No further changes needed.
  * [faf59a7] d/copyright: Update year data, remove non existing data
  * [8fde77f] d/control: Use libncurses-dev within Build-Depends

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 05 Feb 2023 14:44:35 +0100

ngspice (38+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 06 Nov 2022 19:22:51 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  flex,
  gfortran,
  libedit-dev,
- libncurses5-dev,
+ libncurses-dev,
  libtool,
  libxaw7-dev,
  tcl8.6,
@@ -31,7 +31,7 @@
  texlive-plain-generic,
  texlive-science,
 Rules-Requires-Root: binary-targets
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/electronics-team/ngspice
 Vcs-Git: https://salsa.debian.org/electronics-team/ngspice.git
 Homepage: https://ngspice.sourceforge.io

=== debian/watch ===
# watch file for NGSpice

# Upstream isn't doing any signed releases on
#    https://sourceforge.net/projects/ngspice/files/ng-spice-rework/
# By this and due the currently needed repacking for DFSG compliance
# of the source tarball we can't use any cryptographic signature
# verification and don't use 'pgpsigurlmangle'.

# opts= ...
# pgpsigurlmangle=s/archive\/(\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/ \
# ...

version=4

opts="mode=git, \
  uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/; \
                 s/\.\.//; \
                 s/_/\./;  \
                 s/-/\./,  \
  dversionmangle=s/\+ds(\.?\d+)?$//" \
  https://git.code.sf.net/p/ngspice/ngspice.git \
  refs/tags/ngspice-(\d{2}(?:|\.\d+|_\d+|-\d))

## ngspice 39.3+ds

=== src/include/cppduals/CMakeLists.txt ===
#
# CMake for cppduals
#
cmake_minimum_required (VERSION 3.1)
project (cppduals
  VERSION 0.3.1
  LANGUAGES C CXX
  )
include (GNUInstallDirs)

set (CMAKE_CXX_STANDARD 11 CACHE STRING "Which C++ standard to test against.")
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    message (STATUS "Configuring cppduals for standalone build")
    set (CPPDUALS_STANDALONE TRUE)
elseif ()
    message (STATUS "Configuring cppduals for subproject build")
    set (CPPDUALS_STANDALONE FALSE)
endif ()
if (CPPDUALS_STANDALONE AND
    NOT CMAKE_CONFIGURATION_TYPES AND
    NOT CMAKE_NO_BUILD_TYPE AND
    NOT CMAKE_BUILD_TYPE
    )
  message (STATUS "Setting build type to 'RelWithDebInfo' since none specified")
  set_property (CACHE CMAKE_BUILD_TYPE PROPERTY VALUE RelWithDebInfo)
  set_property (CACHE CMAKE_BUILD_TYPE PROPERTY
    STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo"
    )
endif ()
if (CPPDUALS_STANDALONE AND
    CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set (CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install"
       CACHE PATH "cppduals installation directory"
       FORCE
       )
  message (STATUS "No install prefix specified; using '${CMAKE_INSTALL_PREFIX}'")
endif ()

set_property (CACHE CMAKE_CXX_STANDARD PROPERTY STRINGS 11 14 17 20)

option (CPPDUALS_TESTING "Enable testing" OFF)
option (CPPDUALS_BENCHMARK "Enable benchmarking" OFF)
option (CPPDUALS_EIGEN_LATEST "Eigen latest" OFF)
option (CPPDUALS_USE_LIBCXX "When testing use flags for libc++" OFF)
set (EIGEN3_INCLUDE_DIRS "" CACHE PATH "Path to Eigen includes" )

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
    "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wpedantic")
endif ()

if (CPPDUALS_BENCHMARK)
  set (CPPDUALS_TESTING ON)
endif (CPPDUALS_BENCHMARK)

if (CPPDUALS_USE_LIBCXX)
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    add_compile_options ("-stdlib=libc++")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++ ") # -lc++abi
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
      "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # this is unfinished...
    set (CPPDUALS_CXX_FLAGS "${CMAKE_CXX_FLAGS} -nostdinc++")
    message (WARNING "libc++ header path must be manually specified using CMAKE_CXX_FLAGS")
    list (APPEND CPPDUALS_CXX_LINKER_FLAGS -nodefaultlibs)
    list (APPEND CPPDUALS_CXX_LIBRARIES c++)
  else ()
    message(FATAL_ERROR "-DCPPDUALS_USE_LIBCXX:BOOL=ON is not supported for this compiler")
  endif ()
endif (CPPDUALS_USE_LIBCXX)

#
# Primary Library Target
#
add_library (cppduals_duals INTERFACE)
target_include_directories (cppduals_duals
  INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )
set_target_properties (cppduals_duals
  PROPERTIES
    EXPORT_NAME duals
    )
add_library (cppduals::duals ALIAS cppduals_duals)

#
# Build external dependencies for testing & benchmarking
#
if (CPPDUALS_TESTING)

  cmake_minimum_required (VERSION 3.10) # need gtest_discover_tests
  file (MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty")

  # generator name
  if (NOT "${CMAKE_EXTRA_GENERATOR}" STREQUAL "")
    set (GENERATOR_STRING "${CMAKE_EXTRA_GENERATOR} - ${CMAKE_GENERATOR}")
  else ()
    set (GENERATOR_STRING "${CMAKE_GENERATOR}")
  endif ()

  # configure the thirdparty build dir
  execute_process (
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty"
    COMMAND ${CMAKE_COMMAND} "-G${GENERATOR_STRING}"
                             "-DCMAKE_CONFIGURATION_TYPES=${CMAKE_CONFIGURATION_TYPES}"
                             "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
                             "-DCMAKE_MAKE_PROGRAM=${CMAKE_MAKE_PROGRAM}"
                             "-DCPPDUALS_BENCHMARK=${CPPDUALS_BENCHMARK}"
                             "-DCPPDUALS_EIGEN_LATEST=${CPPDUALS_EIGEN_LATEST}"
                             "-DCPPDUALS_USE_LIBCXX=${CPPDUALS_USE_LIBCXX}"
                             "${PROJECT_SOURCE_DIR}/thirdparty"
    RESULT_VARIABLE DEPS_CONFIG_RESULT
    )
  if (DEPS_CONFIG_RESULT)
    message (FATAL_ERROR "Configuring dependencies failed: ${DEPS_CONFIG_RESULT}")
  endif ()

  # build the thirdparty
  message ("***************************************************************")
  message ("** Building '${PROJECT_BINARY_DIR}/thirdparty'...")
  message ("***************************************************************")
  execute_process (
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/thirdparty"
    COMMAND "${CMAKE_COMMAND}" --build .
    RESULT_VARIABLE DEPS_BUILD_RESULT
    )
  message ("***************************************************************")
  message ("*** Building thirdparty/ done.")
  message ("***************************************************************")
  if (DEPS_BUILD_RESULT)
    message ("***************************************************************")
    message (FATAL_ERROR "Building dependencies failed: ${DEPS_BUILD_RESULT}")
    message ("***************************************************************")
  endif ()

  add_subdirectory (thirdparty)

endif ()

#
# Code Coverage Configuration
#
add_library (cppduals_coverage_config INTERFACE)
option (CODE_COVERAGE "Enable coverage reporting" OFF)
if (CODE_COVERAGE AND CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  # Add required flags (GCC & LLVM/Clang)
  target_compile_options (cppduals_coverage_config INTERFACE
    -O0        # no optimization
    -g         # generate debug info
    --coverage # sets all required flags
    )
  if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.13)
    target_link_options (cppduals_coverage_config INTERFACE --coverage)
  else ()
    target_link_libraries (cppduals_coverage_config INTERFACE --coverage)
  endif ()
endif ()

#
# Testing
#
if (CPPDUALS_TESTING)
  enable_testing ()
  include (CTest)
  add_subdirectory (tests)
endif (CPPDUALS_TESTING)

#
# Documentation
#
find_program (DOXYGEN doxygen)
if (DOXYGEN)
  configure_file (${PROJECT_SOURCE_DIR}/doc/Doxyfile.in       ${PROJECT_BINARY_DIR}/doc/Doxyfile)
  configure_file (${PROJECT_SOURCE_DIR}/doc/DoxygenLayout.xml ${PROJECT_BINARY_DIR}/doc/DoxygenLayout.xml COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/header.html       ${PROJECT_BINARY_DIR}/doc/header.html COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/footer.html       ${PROJECT_BINARY_DIR}/doc/footer.html COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/favicon.ico       ${PROJECT_BINARY_DIR}/doc/favicon.ico COPYONLY)
  configure_file (${PROJECT_SOURCE_DIR}/doc/customdoxygen.css ${PROJECT_BINARY_DIR}/doc/customdoxygen.css)
  add_custom_target (cppduals_docs
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doc
    COMMAND cmake -E remove_directory ${PROJECT_BINARY_DIR}/docs
    COMMAND ${DOXYGEN} Doxyfile
    )
else ()
  add_custom_target (cppduals_docs
    COMMAND echo "Please install doxygen and reconfigure to build the docs"
    )
endif ()

#
# Installation
#
install (TARGETS cppduals_duals EXPORT cppduals_export)
install (EXPORT cppduals_export
  FILE cppduals-config.cmake
  NAMESPACE cppduals::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/cppduals
  )
install (
  DIRECTORY ${PROJECT_SOURCE_DIR}/duals
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PATTERN "*~" EXCLUDE
  )
install (
  DIRECTORY ${PROJECT_BINARY_DIR}/docs/   # Trailing slash triggers rename
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/doc/cppduals
  OPTIONAL
  )

#
# etags
#
find_program (ETAGS etags)
if (ETAGS)
  add_custom_target (cppduals_etags
    COMMAND ${ETAGS} --language=c++ ${PROJECT_SOURCE_DIR}/duals/*
    COMMAND ${ETAGS} --language=c++ --append ${PROJECT_SOURCE_DIR}/duals/arch/*/*
    COMMAND ${ETAGS} --language=c++ --append `find ${PROJECT_BINARY_DIR}/thirdparty/eigenX/src/eigenX -type f`
    )
endif (ETAGS)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# out of tree build folder for ngspice application
DEB_BUILD_DIR=debian/build
# default install folder
INSTDIR=$(CURDIR)/debian/tmp

LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DEB_DEFAULT_CONFIGURE_OPTS := \
	--prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--enable-cider \
	--enable-maintainer-mode \
	--enable-openmp \
	--enable-pss \
	--enable-xspice \
	--disable-adms \
	--disable-debug \
	$(NULL)

DEB_NGSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-editline=yes \
	--with-x \
	$(NULL)

DEB_LIBNGSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-ngshared \
	$(NULL)

DEB_TCLSPICE_CONFIGURE_OPTS := \
	$(DEB_DEFAULT_CONFIGURE_OPTS) \
	--with-x \
	--with-tcl=/usr/lib/tcl8.6 \
	$(NULL)

DEB_NGSPICE_DOC_CONFIGURE_OPTS := \
	--prefix=/usr \
	--docdir=\$${prefix}/share/doc/ngspice-doc \
	--htmldir=\$${prefix}/share/doc/ngspice-doc \
	--with-lyxuserdir=$(CURDIR)/$(DEB_BUILD_DIR)/lyxuserdir \
	$(NULL)

PREPROCESS_FILES := $(wildcard debian/*.in)

$(PREPROCESS_FILES:.in=): %: %.in
	sed 's,/@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH:%=/%),g' $< > $@

%:
	dh $@

override_dh_auto_configure-arch:
	mkdir -p $(DEB_BUILD_DIR)
	#
	####################################
	# configuring ngspice applications #
	####################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice -- $(DEB_NGSPICE_CONFIGURE_OPTS)
	#
	##################################
	# configuring libngspice library #
	##################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice -- $(DEB_LIBNGSPICE_CONFIGURE_OPTS)
	#
	##############################
	# configure tclspice library #
	##############################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice -- $(DEB_TCLSPICE_CONFIGURE_OPTS)

override_dh_auto_configure-indep:
	#
	###################################
	# configure ngspice documentation #
	###################################
	cd doc ; autoreconf -vi
	mkdir -p $(DEB_BUILD_DIR)/lyxuserdir/cache
	dh_auto_configure --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc -- $(DEB_NGSPICE_DOC_CONFIGURE_OPTS)

override_dh_auto_build-arch:
	#
	#################################
	# building ngspice applications #
	#################################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice
	#
	###############################
	# building libngspice library #
	###############################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice
	#
	#############################
	# building tclspice library #
	#############################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice

override_dh_auto_build-indep:
	#
	##################################
	# building ngspice documentation #
	##################################
	dh_auto_build --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc

override_dh_auto_install-arch: $(PREPROCESS_FILES:.in=)
	# We need to install the libngspice and tclspice build first
	# and after that the build of the ngspice applications with
	# X support at the end.
	#
	###############################
	# installing tclspice library #
	###############################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/tclspice
	#
	###################################
	# installing ngspice applications #
	###################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/ngspice
	#
	#################################
	# installing libngspice library #
	#################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice
	# remove useless *.la files
	find debian/tmp/ -type f -name "*.la" -exec rm {} \;

override_dh_install-indep:
	#
	####################################
	# installing ngspice documentation #
	####################################
	rm -f $(CURDIR)/doc/manual.pdf
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR)/doc --builddirectory=$(DEB_BUILD_DIR)/ngspice-doc
	dh_install

override_dh_install-arch:
	# Ignore the config.h file, it shouldn't be here anyway.
	rm -f debian/tmp/usr/include/config.h
	dh_install
	# The example scripts contains a wrong path to the libspice0 library after
	# we have installed them into the package.
	for file in `find debian/tclspice/usr/share/doc/tclspice/examples -type f \( -name "*.sh" -o -name "*.tcl" \)`; do \
	    sed -i 's/^load .*/load \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/libspice.so.0/g' $$file ;\
	    sed -i 's/^spice::codemodel ..\/..\/..\/src\/xspice\/icm\/spice2poly\/spice2poly.cm/spice::codemodel \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/ngspice\/spice2poly.cm/g' $$file ;\
	done

override_dh_auto_test:

## ngspice 40+ds

=== debian/changelog ===
ngspice (40+ds-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * [6f31ef4] d/gbp.conf: Adjust to target bookworm

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 22 Jul 2023 06:23:25 +0200

ngspice (40+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 12 Jun 2023 18:33:44 +0200

ngspice (40+ds-1) experimental; urgency=medium

  * [d6ed660] New upstream version 40+ds
  * [80cacf8] d/control: ngspice - Remove dep on install-info
    (Closes: #1013836)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 02 Apr 2023 11:55:48 +0200

## ngspice 41+ds

=== debian/changelog ===
ngspice (41+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 21 Aug 2023 07:34:02 +0200

ngspice (41+ds-1) unstable; urgency=medium

  * [492e094] New upstream version 41+ds

 -- Carsten Schoenert <c.schoenert@t-online.de>  Wed, 16 Aug 2023 21:06:03 +0200

=== debian/control ===
--- 
+++ 
@@ -39,7 +39,6 @@
 Package: ngspice
 Architecture: any
 Depends:
- dpkg (>= 1.15.4) | install-info,
  ${misc:Depends},
  ${shlibs:Depends},
 Suggests:

## ngspice 42%2Bds

=== debian/changelog ===
ngspice (42+ds-3build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:15:14 +0000

ngspice (42+ds-3) unstable; urgency=medium

  * [6cc983c] Rebuild patch queue from patch-queue branch
    Added patch:
    fixes/main.c-Include-.-misc-tilde.h-if-HAVE_BSDEDITLINE-is-set.patch
    (Closes: #1066482)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 17 Mar 2024 06:49:30 +0100

ngspice (42+ds-2) unstable; urgency=medium

  * [24ea4b5] d/rules: Move to override_dh_installexamples-arch

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 31 Dec 2023 08:48:54 +0100

ngspice (42+ds-1) unstable; urgency=medium

  * [cbf8ec8] New upstream version 42+ds
  * [8952631] Add patch from patch queue branch
    Added patches:
    fixes/spelling-Fix-misspelled-word-Onkown.patch
    fixes/spelling-Fix-misspelled-word-initalization.patch
    fixes/spelling-Fix-misspelled-word-positve.patch
  * [97a0aa2] d/rules: Add new configure options
    Added new configure options, using now --enable-klu and --enable-osdi
    additional to the existing ones.
  * [cc2da3e] d/control: Extend package description due OSDI interface
  * [1ec77cf] d/ngspice.examples: Add sequencer file for ngspice
  * [a0f6797] d/tclspice.examples: Add sequencer for tclspice
  * [153ff3f] d/control: Move parts over to override_dh_installexamples
  * [dd8a8cc] d/libngspice0.symbols: Adjust symbol list for 42+ds
  * [ae06873] d/rules: Add target override_dh_cleani
    (Closes: #1046496)
  * [e6abfce] d/ngspice.install.in: Adding new shipped script
  * [bc2076b] d/tclspice.lintian-overrides: Add additional override
  * [33fd1ce] d/libngspice0.lintian-overrides: Add override

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 30 Dec 2023 20:56:35 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ngspice
 Section: electronics
 Priority: optional
-Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders:
  Gudjon I. Gudjonsson <gudjon@gudjon.org>,
  Andreas Tille <tille@debian.org>,
@@ -46,7 +47,8 @@
 Description: Spice circuit simulator
  NGSpice is a mixed-level/mixed-signal circuit simulator.  Its code is based on
  three open source software packages:
- Spice3f5, Cider1b1 and Xspice.
+ Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
+ the built-in OSDI interface.
  .
  NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
  Automation tools.
@@ -61,7 +63,8 @@
 Description: Spice circuit simulator - development files for ngspice and tclspice
  NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
  three open source software packages:
- Spice3f5, Cider1b1 and Xspice.
+ Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
+ the built-in OSDI interface.
  .
  Use this package in case you need to compile own Xspice models as a dynamic
  library with a file extension *.cm. Those files need to be placed into
@@ -85,7 +88,8 @@
  library libspice.
  All spice directives are available as Tcl functions and it features some new
  commands that are useful for the integration into the Tcl environment. It
- includes Xspice.
+ includes Xspice. It supports also compiled Verilog-A models through the
+ built-in OSDI interface.
  GUI is handled by Tk using BLT vectors.
 
 Package: ngspice-doc
@@ -97,7 +101,8 @@
 Description: Documentation for the NGspice circuit simulator
  NGspice is a mixed-level/mixed-signal circuit simulator.
  Its code is based on three open source software packages:
- Spice3f5, Cider1b1 and Xspice.
+ Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
+ the built-in OSDI interface.
  .
  NGSpice is part of gEDA project, a full GPL'd suite of Electronic Design
  Automation tools.
@@ -114,7 +119,8 @@
 Description: Spice circuit simulator - library
  NGspice is a mixed-level/mixed-signal circuit simulator. Its code is based on
  three open source software packages:
- Spice3f5, Cider1b1 and Xspice.
+ Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
+ the built-in OSDI interface.
  .
  This package contains the NGSpice library.
 
@@ -128,6 +134,7 @@
 Description: Spice circuit simulator - development files for libngspice
  NGSpice is a mixed-level/mixed-signal circuit simulator. Its code is based on
  three open source software packages:
- Spice3f5, Cider1b1 and Xspice.
+ Spice3f5, Cider1b1 and Xspice. It supports compiled Verilog-A models through
+ the built-in OSDI interface.
  .
  This package contains the development files for NGSpice.

## ngspice 42+ds

=== debian/changelog ===
ngspice (42+ds-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 05 Jan 2024 19:40:55 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ngspice
 Section: electronics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
+Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
 Uploaders:
  Gudjon I. Gudjonsson <gudjon@gudjon.org>,
  Andreas Tille <tille@debian.org>,

## ngspice 43+ds

=== debian/changelog ===
ngspice (43+ds-1) unstable; urgency=medium

  * [27ef54f] New upstream version 43+ds
  * [a66babc] Rebuild patch queue from patch-queue branch
    Added patch:
    fixes/examples-Turn-some-file-encoding-into-UTF-8.patch
    Removed patches (included upstream):
    fixes/main.c-Include-.-misc-tilde.h-if-HAVE_BSDEDITLINE-is-set.patch
    fixes/spelling-Fix-misspelled-word-Unkown.patch
    fixes/spelling-Fix-misspelled-word-initalization.patch
    fixes/spelling-Fix-misspelled-word-positve.patch
  * [915ca1a] d/control: Add B-D on libreadline-dev
  * [2f34021] d/libngspice0.install.in: Be more lazy on lib versions
  * [5016dbb] d/libngspice0.symbols: Add new symbol
  * [0b39323] d/ngspice.lintian-overrides: Add files to ignore

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 16 Jul 2024 16:54:50 +0200

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
  gfortran,
  libedit-dev,
  libncurses-dev,
+ libreadline-dev,
  libtool,
  libxaw7-dev,
  tcl8.6,

## ngspice 44+ds

=== debian/changelog ===
ngspice (44+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 08 Aug 2024 13:16:43 +0200

ngspice (44+ds-1) unstable; urgency=medium

  * [806a117] New upstream version 44+ds
  * [fe79eb4] Rebuild patch queue from patch-queue branch
    Added patch:
    fixes//Make-source-buildable-out-of-tree.patch
    Dropped patch (included upstream):
    fixes/examples-Turn-some-file-encoding-into-UTF-8.patch
    Renamed patch:
    spelling-Fix-misspelled-word-unkownwq.patch
    -> spelling-Fix-misspelled-word-unkown.patch
  * [68e8af9] ngspice.docs: Update files to install
  * [80d4c1e] d/rules: Also remove *.a files in debian/tmp
  * [97161f0] d/ngspice.install.in: Install new *.so files
  * [0eca610] d/control: Increase Standards-Version to 4.7.0
    No further changes needed.
  * [3f35be6] d/libngspice0.lintian-overrides: Drop sequencer file
  * [08f1716] d/tclspice.lintian-overrides: Adjust content
  * [a8fe0b4] d/libngspice0.symbols: Add new symbols in 44+ds
  * [4506cc6] d/rules: Remove execution rights on *.so and *.vpi files

 -- Carsten Schoenert <c.schoenert@t-online.de>  Tue, 07 Jan 2025 18:20:59 +0200

ngspice (43+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Thu, 08 Aug 2024 13:16:43 +0200

=== debian/control ===
--- 
+++ 
@@ -32,7 +32,7 @@
  texlive-plain-generic,
  texlive-science,
 Rules-Requires-Root: binary-targets
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/electronics-team/ngspice
 Vcs-Git: https://salsa.debian.org/electronics-team/ngspice.git
 Homepage: https://ngspice.sourceforge.io

## ngspice 44.2+ds

=== src/include/cppduals/tests/CMakeLists.txt ===
#
# Part of the cppduals Project
#
# (c)2019 Michael Tesch. tesch1@gmail.com
#
# See https://gitlab.com/tesch1/cppduals/blob/master/LICENSE.txt for
# license information.
#
# This Source Code Form is subject to the terms of the Mozilla
# Public License v. 2.0. If a copy of the MPL was not distributed
# with this file, You can obtain one at http://mozilla.org/MPL/2.0/.

# gtest_discover_tests requires 3.10
cmake_minimum_required (VERSION 3.10)

# Configure google-test as a downloadable library.
include (GoogleTest)

if (WIN32)
  add_definitions (-D_USE_MATH_DEFINES)
endif ()
include_directories ("${CMAKE_SOURCE_DIR}")
include_directories ("${DEPS_ROOT}/include")
include_directories ("${EIGEN3_INCLUDE_DIRS}")
#include_directories ("${MPFR_INCLUDES}")
include_directories ("${EXPOKIT_INCLUDE_DIR}")

set (IOFORMAT "IOFormat(FullPrecision, DontAlignCols, \", \", \"\\$<SEMICOLON>\\n\", \"\", \"\", \"[\", \"]\")")
add_definitions (-DEIGEN_DEFAULT_IO_FORMAT=${IOFORMAT})
#add_definitions (-DEIGEN_DEFAULT_IO_FORMAT=EIGEN_IO_FORMAT_OCTAVE)

#
# Correctness & Coverage
#
if (NOT MSVC)
  set (OPT_FLAGS "-O2")
  set (OPT_FLAGS "-O3;-msse3")
  set (OPT_FLAGS "-O3;-mavx2;-mfma")
  set (OPT_FLAGS "-O3;-march=native")
else ()
  set (OPT_FLAGS "/arch:IA32")
  set (OPT_FLAGS "/arch:SSE")
  set (OPT_FLAGS "/arch:SSE2")
  set (OPT_FLAGS "/arch:AVX2")
endif ()

#set (OPT_FLAGS "${OPT_FLAGS};-fsanitize=address;-fno-omit-frame-pointer")
set (OPT_FLAGS "${OPT_FLAGS};-DCPPDUALS_VECTORIZE_CDUAL")
#set (OPT_FLAGS "${OPT_FLAGS};-DCPPDUALS_DONT_VECTORIZE")
#set (OPT_FLAGS "${OPT_FLAGS};-DEIGEN_DONT_VECTORIZE")

set (ALL_TESTS
  test_dual test_funcs test_eigen test_packets
  test_vectorize test_solve test_expm test_1 test_fmt
  example
  )
set (ALL_TEST_BINS )
foreach (TEST_ ${ALL_TESTS})
  foreach (PHASE 1 2 3 4 5)
    # check if file has phase defined
    file (READ ${TEST_}.cpp TMPTXT)
    string (FIND "${TMPTXT}" "PHASE_${PHASE}" hasphase)
    if ((${hasphase} EQUAL -1) AND NOT (${PHASE} EQUAL 1))
      continue ()
    endif ()

    set (TEST ${TEST_}_${PHASE})
    message ("Adding test ${TEST}")
    set (ALL_TEST_BINS ${ALL_TEST_BINS} ${TEST})

    add_executable (${TEST} ${TEST_}.cpp)
    set (PHASE_FLAGS ${OPT_FLAGS} -DPHASE_${PHASE})
    string (REPLACE ";" ", " L2 "${CMAKE_CXX_FLAGS}")
    target_compile_options (${TEST} PUBLIC ${PHASE_FLAGS})
    target_compile_definitions (${TEST} PRIVATE "OPT_FLAGS=${L2}")
    target_link_libraries (${TEST} gtest_main cppduals_coverage_config)
    #target_link_libraries (${TEST} -lasan)
    add_dependencies (${TEST} eigenX expokitX)
    gtest_discover_tests (${TEST} TEST_LIST ${TEST}_targets)
    set_tests_properties (${${TEST}_targets} PROPERTIES TIMEOUT 10)
    # -ftest-coverage
  endforeach (PHASE)
endforeach (TEST_)

# special for fmt
target_compile_features (test_fmt_1 PUBLIC cxx_std_14)
target_link_libraries (test_fmt_1 fmt::fmt)

if (CPPDUALS_BENCHMARK)
  #
  # Benchmarks
  #

  message ("searching: ${DEPS_ROOT} for google benchmark libs")
  find_library (BENCHMARK_LIBRARY benchmark PATHS ${DEPS_ROOT}/lib)
  find_library (BENCHMARKM_LIBRARY benchmark_main PATHS ${DEPS_ROOT}/lib)
  #find_library (PTHREAD_LIBRARY pthread)
  message ("BENCHMARK_LIBRARY: ${BENCHMARK_LIBRARY}")
  include_directories ("${BENCHMARK_INC_DIR}")
  if (Boost_FOUND AND NO)
    add_definitions (-DHAVE_BOOST=1)
    include_directories ("${Boost_INCLUDE_DIRS}")
    include_directories ("${PIRANHA_INCLUDE_DIR}")
    include_directories ("${AUDI_INCLUDE_DIR}")
  endif (Boost_FOUND AND NO)

  if (NOT APPLE AND NOT BLA_VENDOR)
    if (NOT BLA_STATIC)
      # default to static
      set (BLA_STATIC OFF)
    endif (NOT BLA_STATIC)
    set (BLA_VENDOR OpenBLAS)
  endif (NOT APPLE AND NOT BLA_VENDOR)
  find_package (BLAS REQUIRED)
  #find_package (LAPACK REQUIRED)
  add_definitions (-DHAVE_BLAS)
  #add_definitions (-DEIGEN_USE_BLAS)

  # find lapacke.h cblas.h
  set (CBLAS_HINTS ${BLAS_DIR} ${LAPACK_DIR} /usr /usr/local /opt /opt/local)
  set (CBLAS_PATHS
    /usr
    /usr/local
    /opt
    /opt/local
    /usr/local/opt
    /System/Library/Frameworks)

  # Finds the include directories for lapacke.h
  find_path (LAPACKE_INCLUDE_DIRS
    NAMES lapacke.h
    HINTS ${CBLAS_HINTS}
    PATH_SUFFIXES
    include inc include/x86_64 include/x64
    openblas/include
#    Accelerate.framework/Versions/Current/Frameworks/vecLib.framework/Versions/Current/Headers
    PATHS ${CBLAS_PATHS}
    DOC "LAPACK(E) include header lapacke.h")
  mark_as_advanced (LAPACKE_INCLUDE_DIRS)
  if (LAPACKE_INCLUDE_DIRS)
    include_directories (${LAPACKE_INCLUDE_DIRS})
  else ()
    add_definitions (-DEIGEN_LAPACKE)
  endif (LAPACKE_INCLUDE_DIRS)

  # Finds the include directories for cblas*.h
  find_path (CBLAS_INCLUDE_DIRS
    NAMES cblas.h cblas_openblas.h cblas-openblas.h
    HINTS ${CBLAS_HINTS}
    PATH_SUFFIXES
    include inc include/x86_64 include/x64
    openblas/include
#    Accelerate.framework/Versions/Current/Frameworks/vecLib.framework/Versions/Current/Headers
    PATHS ${CBLAS_PATHS}
    DOC "BLAS include header cblas.h")
  mark_as_advanced (CBLAS_INCLUDE_DIRS)
  include_directories (${CBLAS_INCLUDE_DIRS})
  foreach (cblas in cblas.h cblas_openblas.h cblas-openblas.h)
    if (EXISTS "${CBLAS_INCLUDE_DIRS}/${cblas}")
      add_definitions (-DCBLAS_HEADER="${cblas}")
      break()
    endif (EXISTS "${CBLAS_INCLUDE_DIRS}/${cblas}")
  endforeach (cblas)

  message ("Found BLAS    : ${BLAS_LIBRARIES}")
  message ("Found cBLAS   : ${CBLAS_INCLUDE_DIRS}")
  message ("Found lapacke : ${LAPACKE_INCLUDE_DIRS}")

  set (OPT_FLAGS "")
  if (NOT MSVC)
    #set (OPT_FLAGS "-O3;-mavx")
    #set (OPT_FLAGS "-O3;-march=native;-fopenmp")
    set (OPT_FLAGS "-O3;-msse3;-fopenmp")
    set (OPT_FLAGS "-O3")
    set (OPT_FLAGS "-O3;-msse3")
    set (OPT_FLAGS "-O3;-march=native;-funroll-loops")
    set (OPT_FLAGS "-O3;-msse3;-mavx2;-mfma")
    set (OPT_FLAGS "-O3;-march=native")
    #set (OPT_FLAGS "${OPT_FLAGS};-save-temps;-fverbose-asm")
  else ()
    set (OPT_FLAGS "/arch:IA32")
    set (OPT_FLAGS "/arch:SSE")
    set (OPT_FLAGS "/arch:SSE2")
    set (OPT_FLAGS "/arch:AVX2")
  endif ()

  #set (OPT_FLAGS "${OPT_FLAGS};-DEIGEN_DONT_VECTORIZE")
  #set (OPT_FLAGS "${OPT_FLAGS};-DCPPDUALS_DONT_VECTORIZE")
  #set (OPT_FLAGS "${OPT_FLAGS};-DCPPDUALS_DONT_VECTORIZE_CDUAL")

  foreach (BENCH  bench_dual bench_eigen bench_gemm bench_example bench_fmt)
    add_executable (${BENCH} ${BENCH}.cpp)
    target_compile_options (${BENCH} PUBLIC ${OPT_FLAGS})
    #set_target_properties (${BENCH} PROPERTIES LINK_FLAGS -fopenmp)
    #target_link_options (${BENCH} PUBLIC ${OPT_FLAGS})
    string (REPLACE ";" ", " L2 "${OPT_FLAGS} ${CMAKE_CXX_FLAGS}")
    target_compile_definitions (${BENCH} PRIVATE "OPT_FLAGS=${L2}")
    add_dependencies (${BENCH} benchmarkX eigenX expokitX)
    target_link_libraries (${BENCH} ${BENCHMARK_LIBRARY} -lpthread ${BLAS_LIBRARIES})
  endforeach (BENCH)

  target_link_libraries (bench_fmt fmt::fmt)

endif (CPPDUALS_BENCHMARK)

add_executable (sandbox sandbox.cpp)
add_dependencies (sandbox eigenX expokitX ) # mpfrX mprealX
#target_compile_options (sandbox PUBLIC ${OPT_FLAGS})
target_compile_options (sandbox PUBLIC -DCPPDUALS_VECTORIZE_CDUAL)
if (MSVC)
  target_compile_options (sandbox PUBLIC /arch:AVX2)
else ()
  target_compile_options (sandbox PUBLIC -O1 -msse3 -mavx2 -mfma)
endif ()

set_target_properties (sandbox PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
target_link_libraries (sandbox PUBLIC cppduals_coverage_config)

#
# Generate coverage reports
#
if (CODE_COVERAGE)
  add_custom_target (cov
    DEPENDS ${ALL_TEST_BINS}
    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target test
    COMMAND $<TARGET_FILE:sandbox>
    COMMAND lcov --capture --directory . --output-file coverage.info
    COMMAND lcov --remove coverage.info '/usr/*' --output-file coverage.info
    COMMAND lcov --remove coverage.info '*/thirdparty/*' --output-file coverage.info
    COMMAND lcov --remove coverage.info '*/googletest/*' --output-file coverage.info
    COMMAND lcov --list coverage.info
    )
  add_custom_target (cov-html
    DEPENDS cov
    COMMAND rm -rf ../coverage
    COMMAND genhtml --ignore-errors source coverage.info --legend --title "make cov"
    --output-directory=../coverage
    COMMAND echo "output in coverage/index.html"
    )
endif ()

=== debian/changelog ===
ngspice (44.2+ds-1) unstable; urgency=medium

  * [edd6342] New upstream version 44.2+ds
  * [1faaeab] Rebuild patch queue from patch-queue branch
    Dropped patch (included upstream):
    fixes/Make-source-buildable-out-of-tree.patch

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 12 Jan 2025 10:19:15 +0200

=== debian/rules ===
--- 
+++ 
@@ -23,8 +23,10 @@
 	--prefix=/usr \
 	--mandir=\$${prefix}/share/man \
 	--enable-cider \
+	--enable-klu \
 	--enable-maintainer-mode \
 	--enable-openmp \
+	--enable-osdi \
 	--enable-pss \
 	--enable-xspice \
 	--disable-adms \
@@ -62,6 +64,11 @@
 
 %:
 	dh $@
+
+override_dh_clean:
+	dh_clean
+	rm -f doc/Makefile.in doc/aclocal.m4 doc/configure
+	rm -rf debian/build
 
 override_dh_auto_configure-arch:
 	mkdir -p $(DEB_BUILD_DIR)
@@ -133,8 +140,10 @@
 	# installing libngspice library #
 	#################################
 	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/libngspice
-	# remove useless *.la files
-	find debian/tmp/ -type f -name "*.la" -exec rm {} \;
+	# remove useless *.a and *.la files
+	find debian/tmp/ -type f \( -name "*.a" -o -name "*.la" \) -exec rm {} \;
+	# remove potential execution rights on *.so and *.vpi files
+	find debian/tmp/ -type f \( -name "*.so" -o -name "*.vpi" \) -exec chmod -x {} \;
 
 override_dh_install-indep:
 	#
@@ -149,11 +158,16 @@
 	# Ignore the config.h file, it shouldn't be here anyway.
 	rm -f debian/tmp/usr/include/config.h
 	dh_install
+
+override_dh_installexamples-arch:
+	dh_installexamples
 	# The example scripts contains a wrong path to the libspice0 library after
 	# we have installed them into the package.
 	for file in `find debian/tclspice/usr/share/doc/tclspice/examples -type f \( -name "*.sh" -o -name "*.tcl" \)`; do \
 	    sed -i 's/^load .*/load \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/libspice.so.0/g' $$file ;\
 	    sed -i 's/^spice::codemodel ..\/..\/..\/src\/xspice\/icm\/spice2poly\/spice2poly.cm/spice::codemodel \/usr\/lib\/$(DEB_HOST_MULTIARCH)\/ngspice\/spice2poly.cm/g' $$file ;\
 	done
+	mv debian/ngspice/usr/share/doc/ngspice/examples/optran/models/Models-for-Debian.txt debian/ngspice/usr/share/doc/ngspice/
+	find debian/ngspice/usr/share/doc/ngspice/examples -type f -exec chmod -x {} \;
 
 override_dh_auto_test:

## ngspice 45.2%2Bds

=== debian/changelog ===
ngspice (45.2+ds-1) unstable; urgency=medium

  * [157fa47] d/watch: Convert to version 5
  * [31f0511] New upstream version 45.2+ds
  * [cd5bc04] Rebuild patch queue from patch-queue branch
    Added patches:
    fixes/spelling-Fix-misspelled-word-occurred.patch
  * [f3135fa] d/copyright: Update the copyright information
  * [3b97d81] d/control: Increase Standards-Version to 4.7.2
    No further changes needed.
  * [3351f3a] d/ngspice.install.in: Install also scripts/ghnggen
  * [1039af9] d/libngspice0.symbols: Add new symbols in 45.2+ds
  * [0042a74] d/tclspice.lintian-overrides: Add additional override
  * [5cb2a01] d/libngspice0.lintian-overrides: Additional override
  * [6acbce8] d/rules: Also remove executable permission on *.cm files

 -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 12 Sep 2025 13:58:13 +0200
